% Demo for using the steerable pyramid software of Eero Simoncelli
%
% Aleksandra Pizurica 2/04
%----------------------------------------------------------------------

clear all;
close all;

InputType=0;
    while (InputType~=1 & InputType~=2 & InputType~=3 & InputType~=4)  
     InputType=input('\nReference image format:\n1. "*.tif"\n2. "*.sg2"\n3. "*.mat"\n4. "*.bin"\n>>  ');
    end
    imload;
    im=SCAN;
    clear SCAN;

%Choose number of decomposition levels and orientations
Levels=input('Number of decomposition levels: ');
Orientations=input('Number of orientations (up to 12): ');
 
[pyr,pind] = buildSFpyr(im,Levels,Orientations-1);
figure('Units','normalized','Position',[0.05 0.55 0.4 0.4]);
showSpyr(pyr,pind);

%Extract and display band per band
figure('Units','normalized','Position',[0.05 0.05 0.4 0.4]);
colormap('gray');

sprintf('PRESS ANY KEY TO VIEW THE NEXT SUBBAND')
for b=1:length(pind)
    BAND=reshape(pyr(pyrBandIndices(pind,b)),pind(b,1),pind(b,2));
    imagesc(BAND);
    title(strcat('Band ',num2str(b),'/',num2str(length(pind))));
    %max(max(abs(BAND)))
    pause;
end

res = reconSFpyr(pyr,pind);
std2(res-im);